stages:
  - prebuild
  - build

# default doesn't support only
# Using extends as a workaround
.default:
  only:
    - main

rclone:
  stage: prebuild
  extends: .default
  # rclone/rclone:latest doesn't have sh
  image: debian:latest
  before_script:
    - apt-get update -qy
    # Neet to install ca-certificates so that rclone
    # doesn't freak out about unknown root certs
    - apt-get install -y ca-certificates
    - apt-get install -y rclone
  script:
    - rm -rf _sheets
    - rm -rf files
    - rclone copy "SRC:${SRC_DIR}/sheets" _sheets
    - rclone copy "SRC:${SRC_DIR}/files" files
  artifacts:
    paths:
      - _sheets
      - files

gulp:
  stage: prebuild
  extends: .default
  image: node:lts
  cache:
    paths:
      - node_modules/
  before_script:
    - echo "@tcyr.us:registry=https://gitlab.com/api/v4/packages/npm/"  > .npmrc
    - npm install
  script:
    - npm run gulp
  artifacts:
    paths:
      - assets/js-vendor
      - assets/css-vendor
      
pages:
  stage: build
  extends: .default
  image: ruby:2.7
  needs: ['rclone', 'gulp']
  variables:
    JEKYLL_ENV: production
    LC_ALL: C.UTF-8
  cache:
    paths:
      - vendor/
  before_script:
    - gem install bundler
    - bundle config set path 'vendor'
    - bundle install
  script:
    - bundle exec jekyll build -d public
  artifacts:
    paths:
      - public
